<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

</body>

</html>
<script type="module">
    import Employee from './Employee.js';
    import CommissionEmployee from './CommissionEmployee.js';
    import HourlyEmployee from './HourlyEmployee.js';
    import SalariedEmployee from './SalariedEmployee.js';
    import BasePlusCommissionEmployee from './BasePlusCommissionEmployee.js';

    // Khởi tạo đối tượng Employee
    const employee = new Employee('John', 'Doe', '123-45-6789');
    console.log(employee);

    // Kiểm tra instance của đối tượng
    console.log(employee instanceof Employee);
    console.log(employee instanceof CommissionEmployee);
    console.log(employee instanceof HourlyEmployee);
    console.log(employee instanceof SalariedEmployee);
    console.log(employee instanceof BasePlusCommissionEmployee);

    // Khởi tạo đối tượng CommissionEmployee
    const commissionEmployee = new CommissionEmployee('Alice', 'Smith', '987-65-4321', 100000, 0.1);
    console.log(commissionEmployee);

    // Kiểm tra instance của đối tượng
    console.log(commissionEmployee instanceof Employee);
    console.log(commissionEmployee instanceof CommissionEmployee);
    console.log(commissionEmployee instanceof HourlyEmployee);
    console.log(commissionEmployee instanceof SalariedEmployee);
    console.log(commissionEmployee instanceof BasePlusCommissionEmployee);

    // Khởi tạo đối tượng HourlyEmployee
    const hourlyEmployee = new HourlyEmployee('Bob', 'Johnson', '567-89-0123', 15, 40);
    console.log(hourlyEmployee);

    // Kiểm tra instance của đối tượng
    console.log(hourlyEmployee instanceof Employee);
    console.log(hourlyEmployee instanceof CommissionEmployee);
    console.log(hourlyEmployee instanceof HourlyEmployee);
    console.log(hourlyEmployee instanceof SalariedEmployee);
    console.log(hourlyEmployee instanceof BasePlusCommissionEmployee);

    // Khởi tạo đối tượng SalariedEmployee
    const salariedEmployee = new SalariedEmployee('Emma', 'Wilson', '234-56-7890', 5000);

    // Kiểm tra instance của đối tượng
    console.log(salariedEmployee instanceof Employee);
    console.log(salariedEmployee instanceof CommissionEmployee);
    console.log(salariedEmployee instanceof HourlyEmployee);
    console.log(salariedEmployee instanceof SalariedEmployee);
    console.log(salariedEmployee instanceof BasePlusCommissionEmployee);

    // Khởi tạo đối tượng BasePlusCommissionEmployee
    const basePlusCommissionEmployee = new BasePlusCommissionEmployee('Tom', 'Brown', '456-78-9012', 200000, 0.15, 5000);

    // Kiểm tra instance của đối tượng
    console.log(basePlusCommissionEmployee instanceof Employee);
    console.log(basePlusCommissionEmployee instanceof CommissionEmployee);
    console.log(basePlusCommissionEmployee instanceof HourlyEmployee);
    console.log(basePlusCommissionEmployee instanceof SalariedEmployee);
    console.log(basePlusCommissionEmployee instanceof BasePlusCommissionEmployee);

</script>